/* ibdf3 - close.c */

#include "df3_priv.h"

#include <sys/mman.h>
#include <unistd.h>


df3Error df3_close_file(df3Handle *df3) {

  if (!df3  ||  !df3ValidHandle(df3))
    return ecBadHandle;

  df3Error ec = ecOk;
  if (df3->ismapped) {
    mmFile * const p = df3->dp;
    if (close(p->fd)) {
      df3->syserr = errno;
      ec = df3->ec = ecSysErr;
    }
    if (munmap(p->dp, p->n)) {
      df3->syserr = errno;
      ec = df3->ec = ecSysErr;
    }
    free(p);
  }
  else if (fclose(df3->dp)) {
    df3->syserr = errno;
    ec = df3->ec = ecSysErr;
  }

  /* invalidate handle */
  df3->dp = NULL;
  df3->bpv = 0;

  return ec;
}

/* ----------------------------------------------------------------- *
 *  this file is part of 'libdf3', part of the 'df3 tools' project.  *
 *  the content above is covered by the GPLv3+, see file COPYING.    *
 *  copyright (c) 2017 jr <creature.eternal@gmail.com>.              *
 *  all rights reserved.                                             *
 * ----------------------------------------------------------------- */
